﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using OpenTK;
using Aiv.Fast2D;
using Aiv.Audio;

namespace ggj_2017.Elia {
    public class Tile : GameObject {

        float tempoPassato;
        AudioClip audio;
        AudioSource player;
        float tempoPassatoMax = 3.3f;
        string nomeAudio = "";

        public Tile(Vector2 position, string textureName, Vector2 SpriteDimension, string nomeAudio) : base(position, textureName, SpriteDimension) {
            this.nomeAudio = nomeAudio;

            sprite = new Sprite(SpriteDimension.X, SpriteDimension.Y);
            //sprite.pivot = new Vector2(SpriteDimension.X / 2, SpriteDimension.Y / 2);
            sprite.position = position;
            tempoPassato = tempoPassatoMax;
            rigidBody = new RigidBody(new Vector2(sprite.position.X, sprite.position.Y), this, true);
            rigidBody.IsGravityAffected = false;
            rigidBody.Velocity = new Vector2(0, 0);
        }

        public Tile(Vector2 position, string textureName, Vector2 SpriteDimension) : base(position, textureName, SpriteDimension) {
            sprite = new Sprite(SpriteDimension.X, SpriteDimension.Y);
            //sprite.pivot = new Vector2(SpriteDimension.X / 2, SpriteDimension.Y / 2);
            sprite.position = position;

            rigidBody = new RigidBody(new Vector2(sprite.position.X, sprite.position.Y), this, true);
            rigidBody.IsGravityAffected = false;
            rigidBody.Velocity = new Vector2(0, 0);
            tempoPassato = 0.40f;
        }

        public override void Draw() {
            if (nomeAudio.Equals("")) {
                tempoPassato -= Game.window.deltaTime;
                if (tempoPassato > 0.33f) {
                    sprite.DrawTexture(texture, 0, 0, (int)sprite.Width, (int)sprite.Height);
                }else {
                    sprite.DrawTexture(texture, (int)sprite.Width, 0, (int)sprite.Width, (int)sprite.Height);
                }
                if (tempoPassato <= 0) {
                    tempoPassato = 0.40f;
                }
            } else {
                if (tempoPassato >= 3 * tempoPassatoMax / 4) {
                    sprite.DrawTexture(texture, 0, 0, (int)sprite.Width, (int)sprite.Height);
                } else
                if (tempoPassato >= tempoPassatoMax / 2 && tempoPassato < 3 * tempoPassatoMax / 4) {
                    sprite.DrawTexture(texture, (int)sprite.Width, 0, (int)sprite.Width, (int)sprite.Height - 1);
                } else
                if (tempoPassato >= tempoPassatoMax / 4 && tempoPassato < tempoPassatoMax / 2) {
                    sprite.DrawTexture(texture, (int)sprite.Width*2, 0, (int)sprite.Width, (int)sprite.Height);
                } else {
                    sprite.DrawTexture(texture, (int)sprite.Width*3, 0, (int)sprite.Width, (int)sprite.Height);
                }
            }
        }

        public void playNota() {
            if (!nomeAudio.Equals("")) {
                audio = Sound.GetAudio(nomeAudio);
                player = new AudioSource();
                player.Volume = 1.8f;
                player.Play(audio);
            }
        }

        public void diminuisciTempo(float secondiPassati) {
            tempoPassato -= secondiPassati;
        }

        public float tempoRimasto() {
            return tempoPassato;
        }

        public int getY() {
            return (int)sprite.position.Y;
        }

        public RigidBody getRigidBody() {
            return this.rigidBody;
        }
    }

}
