﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Aiv.Fast2D;
using Aiv.Audio;
using OpenTK;
using ggj_2017.Piera;
using ggj_2017.Virginia;

namespace ggj_2017
{
    static class Game
    {
        public static Window window;
        public static Camera camera;

        public static List<GameLevel> levels;
        public static int index;

        static Game()
        {
            window = new Window(512, 600, "White Noise");
            window.SetIcon("Assets/favicon.ico");
            levels = new List<GameLevel>();
            levels.Add(new MenuLevel());
            levels.Add(new PlayLevel());
            levels.Add(new GameOverLevel());
            levels.Add(new GameWonLevel());
            levels.Add(new Credits());
            levels.Add(new LogoLevel());
            camera = new Camera();
            index = 5;            

        }


        public static void Draw()
        {          
            levels[index].Draw();           
        }

        public static void Update()
        {
            levels[index].Update();
        }
        public static void Input()
        {
            levels[index].Input();
        }

    }
}
