﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Aiv.Fast2D;
using Aiv.Audio;
using OpenTK;

namespace ggj_2017
{
    public class GameObject
    {
        public Vector2 Position
        {
            get
            {
                return sprite.position;
            }

            protected set
            {
                sprite.position = value;
            }
        }

        public float Width
        {
            get
            {
                return sprite.Width;
            }
        }

        public float Height
        {
            get
            {
                return sprite.Height;
            }
        }

        public bool IsActive { get; set; }

        public Sprite sprite;
        protected Texture texture;
        public RigidBody rigidBody;
        //protected Vector2 direction;
        //protected float speed;

        public GameObject(Vector2 position, String textureName, Vector2 SpriteDimension)
        {
            this.texture = GfxMng.GetTexture(textureName);
            //Console.WriteLine(texture==null);
            sprite = new Sprite(SpriteDimension.X, SpriteDimension.Y);
            this.Position = position;
            //this.direction = new Vector2(direction.X, direction.Y);            
            //this.speed = speed;
            IsActive = true;
        }

        public virtual void Draw()
        {
            if (IsActive)
                sprite.DrawTexture(texture);
        }

        public virtual void Update()
        {
            //if(IsActive)
            //    Position += direction * Game.Window.deltaTime * speed;

            if (rigidBody != null)
                this.sprite.position = rigidBody.Position;

        }

        public virtual void OnCollide(GameObject other)
        {

        }
    }
}
