﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Aiv.Fast2D;
using OpenTK;
using Aiv.Audio;
using ggj_2017.Elia;

namespace ggj_2017
{
    static class PhysicsManager
    {
        public static float G { private set; get; }
        private static List<RigidBody> bodies;

        static PhysicsManager()
        {
            G = 1.5f; 
            bodies = new List<RigidBody>();
        }

        public static void AddBody(RigidBody rb)
        {
            bodies.Add(rb);
        }

        public static void CheckCollision()
        {
            for (int i = 0; i < bodies.Count; i++)
            {
                if (bodies[i].Parent.IsActive)
                    for (int j = i + 1; j < bodies.Count; j++)
                    {
                        if (bodies[j].Parent.IsActive && bodies[i].isColliding(bodies[j]))
                        {
                            bodies[i].Parent.OnCollide(bodies[j].Parent);
                            bodies[j].Parent.OnCollide(bodies[i].Parent);
                        }
                    }
            }

        }

        public static void CheckCollisionWithPlatform(List<Tile> tiles) {
            for (int i = 0; i < bodies.Count; i++) {
                if (bodies[i].Parent.IsActive)
                    for (int j = 0; j < tiles.Count; j++) {
                        if (bodies[i].isColliding(tiles[j].getRigidBody())) {
                            bodies[i].Parent.OnCollide(tiles[j]);
                        }
                    }
            }

        }

        public static void RemoveAll()
        {
            bodies.Clear();
        }

        public static void Update()
        {
            foreach (RigidBody body in bodies)
            {
                body.Update();
            }
        }
    }
}
