﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using OpenTK;
using Aiv.Fast2D;
using Aiv.Audio;
using ggj_2017.Piera;
using ggj_2017.Elia;

namespace ggj_2017
{
    public class Player : GameObject
    {
        public bool isGreek;
        public bool isWinged;
        public bool isChanging1;
        public bool isChanging2;
        public bool isRight;
        public float changingTimer=0f;
        public Vector2 position
        {
            get
            {
                return sprite.position;
            }
            set
            {
                sprite.position = value;
            }
        }
        public Player(Vector2 position, Vector2 SpriteDimension) : base(position, "playerUP", SpriteDimension)
        {
            isRight = true;
            sprite = new Sprite(SpriteDimension.X, SpriteDimension.Y);
            sprite.pivot = new Vector2(SpriteDimension.X / 2, SpriteDimension.Y / 2);
            this.position = position;
            //this.texture = GfxMng.GetTexture(textureName);
            //texture = new Texture(textureName);
            rigidBody = new RigidBody(new Vector2(sprite.position.X - SpriteDimension.X / 2, sprite.position.Y - SpriteDimension.Y / 2), this);
            rigidBody.IsGravityAffected = true;
            rigidBody.Velocity = new Vector2(0, 0);
            IsActive = true;
            isGreek = false;
            isWinged = false;
            isChanging1 = false;
            isChanging2 = false;
            changingTimer = 0.0f;
        }

        public void Input()
        {
            // CHEAT FOR DEBUG

            if (Game.window.GetKey(KeyCode.F)) {
                rigidBody.SetYvelocity(-70);
            }
            if (Game.window.JoystickTriggerLeftRaw(0) > 0 || Game.window.GetKey(KeyCode.Left))
            {
                sprite.scale = new Vector2(-1f, 1f);
                rigidBody.SetXvelocity(-70);
                isRight = false;
            }
            else if (Game.window.JoystickTriggerRightRaw(0) > 0 || Game.window.GetKey(KeyCode.Right))
            {
                sprite.scale = new Vector2(1f, 1f);
                rigidBody.SetXvelocity(70);
                isRight = true;
            }
            else { rigidBody.SetXvelocity(0); }
        }

        public override void Update()
        {
            //base.Update();
            rigidBody.Update();
            if (rigidBody != null)
            {
                sprite.position.X = rigidBody.Position.X + sprite.Width * 0.5f;
                sprite.position.Y = rigidBody.Position.Y + sprite.Height * 0.5f;
            }
            //fisica di rimbalzo e reset su collisione pavimento
            if (rigidBody.geometry.hittingDown)
            {
                rigidBody.SetXvelocity(0f);
                rigidBody.SetYvelocity(-150f);
                rigidBody.geometry.hittingDown = false;
            }
            if (rigidBody.geometry.hittingUp)
            {
                rigidBody.SetYvelocity(0f);
                rigidBody.geometry.hittingUp = false;
            }
            if (rigidBody.Position.Y <= Game.window.Height * 0.5f && IsActive && rigidBody.Position.Y >= -2268)
            {
                //Game.camera.position = Vector2.Lerp(Game.camera.position, new Vector2(0, rigidBody.Position.Y - Game.window.Height * 0.5f), 2f*Game.window.deltaTime);
                Game.camera.position.Y = rigidBody.Position.Y - Game.window.Height * 0.5f;
                Game.camera.position.X = 0;
            }
            //else if (rigidBody.Position.Y <= -2868)
            //    Game.camera.position.Y = -3168;
            PlayLevel altitude = (PlayLevel)(Game.levels[1]);
            if (rigidBody.Position.Y + rigidBody.geometry.Height >= ((PlayLevel)(Game.levels[1])).noise.Position.Y)
            {
                altitude.source.Dispose();
                IsActive = false;
                Game.index = 2;
                Game.camera.position = new Vector2(0, 0);
            }

        }

        public override void Draw()
        {
            if (rigidBody.Velocity.Y >= 0)
            {
                if (!isGreek && !isWinged && !isChanging1)
                    texture = GfxMng.GetTexture("playerDOWN");
                else if (isGreek && !isWinged && !isChanging2)
                    texture = GfxMng.GetTexture("greekDown");
                else if (isGreek && isWinged)
                    texture = GfxMng.GetTexture("wingDown");
            }
            //else if (rigidBody.Velocity.Y < 0 && rigidBody.Velocity.Y >= -100)
            //texture = GfxMng.GetTexture("playerDOWN");
            else
            {
                if (!isGreek && !isWinged && !isChanging1)
                    texture = GfxMng.GetTexture("playerUP");
                else if (isGreek && !isWinged && !isChanging2)
                    texture = GfxMng.GetTexture("greek4");
                else if (isGreek && isWinged)
                    texture = GfxMng.GetTexture("wing5");
            }

            if (rigidBody.Position.Y <= -730 && !isGreek)
            {
                isChanging1 = true;
                changingTimer += Game.window.deltaTime;
                if (changingTimer >= 0f && changingTimer < 0.25f)
                {
                    texture = GfxMng.GetTexture("greek1");
                }
                if (changingTimer >= 0.25f && changingTimer < 0.50f)
                {
                    texture = GfxMng.GetTexture("greek2");
                }
                if (changingTimer >= 0.50f && changingTimer < 0.75f)
                {
                    texture = GfxMng.GetTexture("greek3");
                }
                if (changingTimer >= 0.75f)
                {
                    texture = GfxMng.GetTexture("greek4");
                    changingTimer = 0;
                    isGreek = true;
                }
            }
            if (rigidBody.Position.Y <= -1460 && !isWinged)
            {
                isChanging2 = true;
                changingTimer += Game.window.deltaTime;
                if (changingTimer >= 0f && changingTimer < 0.25f)
                {
                    texture = GfxMng.GetTexture("wing1");
                }
                if (changingTimer >= 0.25f && changingTimer < 0.50f)
                {
                    texture = GfxMng.GetTexture("wing2");
                }
                if (changingTimer >= 0.50f && changingTimer < 0.75f)
                {
                    texture = GfxMng.GetTexture("wing3");
                }
                if (changingTimer >= 0.75f && changingTimer < 1.0f)
                {
                    texture = GfxMng.GetTexture("wing4");

                }
                if (changingTimer >= 1f)
                {
                    texture = GfxMng.GetTexture("wing5");
                    changingTimer = 0;
                    isWinged = true;
                }

            }
            base.Draw();
        }


        public override void OnCollide(GameObject other)
        {
            if (other is PiattaformaVittoria && rigidBody.geometry.hittingDown && position.Y <= - 2000 && position.X <= 125 && position.X >=64)
            {
                Game.levels[1].source.Dispose();
                Game.index = 3;
            }
        }


    }
}
