﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Aiv.Fast2D;
using OpenTK;
using ggj_2017.Elia;
using Aiv.Audio;


namespace ggj_2017.Piera {
    public class PlayLevel : GameLevel {
        public Player player;
        public WhiteNoise noise;
        //public Sprite x;
        public Sprite b;
        public Texture t;
        public PiattaformaVittoria vittoria;
        public float safeDistance;
        public CloudsMgr clouds;

        public TileManager tileManager; 

        public PlayLevel() {
            clouds = new CloudsMgr();
            tileManager = new TileManagerWithLevel();
            player = new Player(new Vector2(50, Game.window.Height-150), new Vector2(25, 50));
            vittoria = new PiattaformaVittoria();
            noise = new WhiteNoise(new Vector2(-100, Game.window.Height + 400), new Vector2(0, 0));            
            t = GfxMng.GetTexture("bg1");
            b = new Sprite(t.Width*2, t.Height*2);
            b.position = new Vector2(0, -2568f);
            //x = new Sprite(Game.window.Width, 10);
            //x.position = new Vector2(0, Game.window.Height - 100);
            theme = Sound.GetAudio("WhiteNoise");
        }

        public override void Draw()

        {
            b.DrawTexture(t);
            clouds.Draw();
            //x.DrawSolidColor(1f, 0f, 0f, 1f);
            player.Draw();
            List<Tile> tiles = tileManager.getPiattaformeVisibili();
            foreach (Tile tile in tiles)
            {
                tile.Draw();
            }
            vittoria.Draw();
            noise.Draw();

        }

        public override void Update()
        {
            clouds.Update();
            vittoria.Update();
            source.Stream(theme, Game.window.deltaTime, true);
            noise.Update();
            player.Update();
            PhysicsManager.CheckCollision();
            PhysicsManager.Update();
            tileManager.aggiornaTile(Game.window.deltaTime, player.Position.Y + player.Height);
            List<Tile> tiles = tileManager.getPiattaformeVisibili();
            PhysicsManager.CheckCollisionWithPlatform(tiles);
            foreach (Tile tile in tiles) {
                tile.Update();
            }
            safeDistance = Math.Abs(noise.Position.Y - player.position.Y);
            source.Volume = 1-safeDistance/700;
        }

        public override void Input()
        {
            player.Input();
        }
      
        
    }
}
