﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ggj_2017.Piera;
using Aiv.Fast2D;
using OpenTK;
using ggj_2017.Elia;

namespace ggj_2017.Virginia
{
    public class GameOverLevel:GameLevel
    {
        public bool isButtonPressed = false;

        public GameOverLevel():base()
        {
            sprite = new Sprite(Game.window.Width, Game.window.Height);            
            sprite.position = new Vector2(0, -100);
            texture = GfxMng.GetTexture("over");
        }

        public override void Draw()
        {
            sprite.DrawTexture(texture);
        }

        public override void Update() {
            Game.camera.position = new Vector2(0, 0);
        }

        public override void Input()
        {
            if (Game.window.GetKey(KeyCode.Return)||Game.window.JoystickStart(0))
            {
                if (!isButtonPressed) {
                    Game.levels[0] = new MenuLevel();
                    Game.levels[1] = new PlayLevel();
                    Game.index = 0;
                    isButtonPressed = false;
                }
            }
            else
                isButtonPressed = false;

        }

        public static void Reset()
        {
            ((PlayLevel)(Game.levels[1])).tileManager = new TileManagerWithLevel();            
           ((PlayLevel)(Game.levels[1])).player.rigidBody.Position = new Vector2(50, Game.window.Height - 250);
            ((PlayLevel)(Game.levels[1])).player.rigidBody.SetXvelocity(0);
            ((PlayLevel)(Game.levels[1])).player.rigidBody.SetYvelocity(0);
            ((PlayLevel)(Game.levels[1])).player.sprite.EulerRotation = 0;
            ((PlayLevel)(Game.levels[1])).player.IsActive = true;            
            ((PlayLevel)(Game.levels[1])).noise = new WhiteNoise(new Vector2(0, Game.window.Height + 400), new Vector2(0, 0));
        }
    }
}
