﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Aiv.Fast2D;
using OpenTK;

namespace ggj_2017
{
    public static class GfxMng
    {
        public static Dictionary<string, Texture> textures;

        static GfxMng()
        {
            textures = new Dictionary<string, Texture>();

            //Backgrounds
            textures.Add("bg1", new Texture("Assets/background/completo.png"));
            textures.Add("cloud1", new Texture("Assets/nuvola1.png"));
            textures.Add("cloud2", new Texture("Assets/nuvole2.png"));
            textures.Add("cloud3", new Texture("Assets/prenuvole.png"));
            textures.Add("cloud4", new Texture("Assets/prenuvole1.png"));
            //textures.Add("bg6", new Texture("Assets/"));
            //textures.Add("bg7", new Texture("Assets/"));
            //textures.Add("bg8", new Texture("Assets/"));

            //Player
            textures.Add("playerUP", new Texture("Assets/Player/up.png"));
            textures.Add("playerDOWN", new Texture("Assets/Player/down.png"));
            textures.Add("playerCROUCH", new Texture("Assets/Player/crouch.png"));
            textures.Add("piattaforma", new Texture("Assets/Piattaforma.png"));
            textures.Add("cassa", new Texture("Assets/amplatform.png"));


            textures.Add("greek1", new Texture("Assets/upgreek1.png"));
            textures.Add("greek2", new Texture("Assets/upgreek2.png"));
            textures.Add("greek3", new Texture("Assets/upgreek3.png"));
            textures.Add("greek4", new Texture("Assets/upgreek4.png"));
            textures.Add("wing1", new Texture("Assets/upwings1.png"));
            textures.Add("wing2", new Texture("Assets/upwings2.png"));
            textures.Add("wing3", new Texture("Assets/upwings3.png"));
            textures.Add("wing4", new Texture("Assets/upwings4.png"));
            textures.Add("wing5", new Texture("Assets/upwings5.png"));
            textures.Add("greekDown", new Texture("Assets/downgreek4.png"));
            textures.Add("wingDown", new Texture("Assets/downwings5.png"));
            textures.Add("burn", new Texture("Assets/burn.png"));
            textures.Add("suicide", new Texture("Assets/suicide.png"));
            textures.Add("walk", new Texture("Assets/walk.png"));

            textures.Add("end1", new Texture("Assets/end1.png"));
            textures.Add("end2", new Texture("Assets/end2.png"));
            textures.Add("end3", new Texture("Assets/end3.png"));
            textures.Add("end4", new Texture("Assets/end4.png"));
            textures.Add("end5", new Texture("Assets/end5.png"));
            textures.Add("end6", new Texture("Assets/end6.png"));
            textures.Add("end7", new Texture("Assets/end7.png"));
            textures.Add("end8", new Texture("Assets/end8.png"));
            textures.Add("end9", new Texture("Assets/end9.png"));
            textures.Add("end10", new Texture("Assets/end10.png"));

            //Platform
            textures.Add("platf", new Texture("Assets/Piattaforma.png"));
            //textures.Add("finalPl", new Texture("Assets/"));


            //Whitenoise
            textures.Add("wn", new Texture("Assets/white noise 2.png"));
            textures.Add("wnTwo", new Texture("Assets/white noise 1.png"));
            //textures.Add("wnThree", new Texture("Assets/noise/white noise 1.png"));
            //textures.Add("wnFour", new Texture("Assets/noise/static2b.png"));
            textures.Add("win", new Texture("Assets/win_platform.png"));
            textures.Add("cancello", new Texture("Assets/cancello.png"));

            textures.Add("menu", new Texture("Assets/MENUSCALED.png"));
            textures.Add("over", new Texture("Assets/GAMEOVERSCALED.png"));
            textures.Add("creds4", new Texture("Assets/TITOLIDICODA.png"));
            textures.Add("logo", new Texture("Assets/Logo.png"));
        }

        public static Texture GetTexture(string textureName)
        {
            if (textures.ContainsKey(textureName))
                return textures[textureName];
            return null;
        }
    }
}
